import os
import filecmp
import datetime

"""CONFIG ZONE"""
TESTS = "./tests"
LOGFILE = "./logfile.txt"
"""END CONFIG ZONE """

class bcolors:
     HEADER = '\033[95m'
     OKBLUE = '\033[94m'
     OKGREEN = '\033[92m'
     WARNING = '\033[93m'
     FAIL = '\033[91m'
     ENDC = '\033[0m'
     BOLD = '\033[1m'
     UNDERLINE = '\033[4m'

def compile(filename):
    os.system("touch {0}.trial.out".format(filename))
    os.system("./scolang.native {1}/{0}.sav >> {0}.ll 2>{0}.trial.out".format(filename,TESTS+"/"))
    if("fail" in filename): return
    os.system("llc {0}.ll > {0}.s".format(filename))
    os.system("gcc -o {0} {0}.s stdlib/scolang_stdlib.o -lcurl -no-pie".format(filename))
    os.system("./{0} > {0}.trial.out".format(filename))
    return

def clean(filename):
    os.system("rm -rf {0}.ll {0}.s ./{0} {0}.trial.out".format(filename))
    return


os.system('echo "====\nSTARTING TESTING"  >>'+LOGFILE)
os.system("echo \'"+str(datetime.datetime.now())+"\n\'>> "+LOGFILE)
#os.system('echo "Making scolang" >> {}'.format(LOGFILE))
#os.system("make")
print("starting test...")

filenames = os.listdir(TESTS)
files = []
successes, failures = [],[]

for file in filenames:
    if(".sav" not in file):
        continue
    filename = file[:file.index(".sav")]
    if("fail" in file):
        files.append(filename)
    elif("test" in file):
        files.append(filename)
    else:
        print("ERRONEOUS FILE :"+filename)

for filename in files:
    compile(filename)
    try:
        success = filecmp.cmp(TESTS+"/"+filename+".out", filename+".trial.out")
    except:
        success = False
        print(filename + " or output not found")

    if(success):
        successes.append(filename)
        print(bcolors.OKGREEN+"[Passed] "+bcolors.ENDC + filename)
    else:
        failures.append(filename)
        print(bcolors.FAIL+"[Failed] "+bcolors.ENDC+bcolors.UNDERLINE+filename + bcolors.ENDC)

    clean(filename)

os.system('echo "\nFAILED TESTS: \n '+(", ".join(failures))+'" >> '+LOGFILE)
os.system('echo "PASSED TESTS: \n '+(", ".join(successes))+'">> '+LOGFILE)
os.system('echo "Successes : {}, Failures: {}\n" >> {}'.format(len(successes),len(failures),LOGFILE))
print(bcolors.HEADER+bcolors.BOLD+"Passed "+str(len(successes))+" out of "+str(len(failures) + len(successes))+" tests."+bcolors.ENDC)
os.system('echo "ENDED TESTING \n==== \n" >> '+LOGFILE)
